///<ObjektNummer>2118</ObjektNummer>

#if !defined(h_DebugUart)
#define h_DebugUart

// Defines
#define F_CPU 20000000
#define MCU ATMEGA644P

#include <avr\io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

//#define IsDEBUG

//#ifndef DEBUG_BAUD
//		#define DEBUG_BAUD 19200
//	#endif
//	#ifndef DEBUG_UART_NR
//	    #define DEBUG_UART_NR 0
//	#endif
#include "debugUart.h"
extern class DebugUart debug;
#ifndef DebugPrintFlash
	#ifdef IsDEBUG
		#define DebugPrintFlash(txt) {debug.printFlash(PSTR(txt)); }
		#define DebugPrintRam(txt,size) {debug.printRam((const char*)(txt),size); }
		#define DebugPrintHex(txt,num) {debug.printFlash(PSTR(txt)); debug.printHex((uint32_t)num); debug.printFlash(PSTR("\n"));}
		#define DebugPrintDez(txt,num) {debug.printFlash(PSTR(txt)); debug.printDez((uint32_t)num); debug.printFlash(PSTR("\n"));}
		#define DebugPrintString(txt,string) {debug.printFlash(PSTR(txt)); debug.printRam((const char*)(string.pBuffer),string.len); debug.printFlash(PSTR("\n"));}
		#define DebugPrintDump(pBuffer,anz) {uint8_t sreg=SREG;cli();debug.printDump((uint8_t*)pBuffer,anz);SREG=sreg; }
		#define DebugPrintAllocFreelist() {uint8_t sreg=SREG;cli();debug.printAllocFreelist();SREG=sreg; }
	#else
		#define DebugPrintFlash(txt) ;
		#define DebugPrintRam(txt,size) ; 
		#define DebugPrintHex(txt,num) ; 
		#define DebugPrintDez(txt,num) ; 
		#define DebugPrintString(txt,string);
		#define DebugPrintDump(pBuffer,anz) ;
		#define DebugPrintAllocFreelist() ;
	#endif
#endif
#include <avr/pgmspace.h>
#include <stdlib.h>

#define String StringBig
/////// DEBUG /////////////
//#define IsDEBUG	// auch im Paket "Debug" schalten
	#define DEBUG_BAUD 500000
	#define DEBUG_UART_NR 0
	#include "debugUart.h"

class DebugUart
{

public:

	//	init()
	void init();

	//	printFlash()
	void printFlash(const char* PROGMEM ptext);

	//	putChar()
	void putChar(char data);

	//	printRam()
	//	wenn size=-1 wird bis 0x00 ausgegeben
	void printRam(const char* ptext, uint16_t size=-1);

	//	printDez()
	void printDez(uint32_t num);

	//	printHex()
	void printHex(uint32_t num);

	//	getChar()
	//	mit Warten bis Daten da sind
	short getChar();

	//	printDump()
	void printDump(uint8_t* buffer, uint32_t length);

	//	printAllocFreelist()
	//	Gibt die Liste der freien Speicherblcke im Heap aus
	void printAllocFreelist();

	//	Konstruktor
	DebugUart();

	//	Destruktor
	~DebugUart();

private:

protected:

};

#endif
