///<ObjektNummer>2920</ObjektNummer>

#if !defined(h_Directory)
#define h_Directory

// Defines
#define F_CPU 20000000
#define MCU ATMEGA644P

#include <avr\io.h>
#include "DirEntryCache.h"

#include "M8_Mx8_SPI.h"

#define String StringBig
/////// DEBUG /////////////
//#define IsDEBUG	// auch im Paket "Debug" schalten
	#define DEBUG_BAUD 500000
	#define DEBUG_UART_NR 0
	#include "debugUart.h"

class Directory
{

public:
	//	fileFind()
	//	Sucht den ersten bzw. nchsten Dateieintrag anhand des vollstndigen Namens oder einer Maske.
	//	Eine Maske kann einen Stern fr restlicher Name/Extention enthalten oder je beliebigen Buchstaben ein '?'.
	//	z.B. *.txt oder hallo*.txt oder hallo*.* oder ha???.txt
	//	
	//	PE:
	//		maske = Maske oder Dateiname, immer in Grobuchstaben
	//		findFirst = true wenn ab Anfang gesucht werden soll
	//		
	//	PA:
	//		false = nicht gefunden, sonst dir gltig; bei Fehlerhafter Syntax wird false zurckgegeben und lastError=11
	virtual bool fileFind(const char* maske, bool findFirst=true);

	//	init()
	void init();
	//	getEntry()
	//	gibt eine Referent auf sein DirEntryCache zurck
	DirEntryCache& getEntry();
	int8_t lastError;
	//	Konstruktor
	Directory();

	//	Destruktor
	~Directory();

private:

protected:

	//	onLongFilename()
	virtual bool onLongFilename(const char* maske);
	DirEntryCache entry;

};

#endif
