///<ObjektNummer>2359</ObjektNummer>

#if !defined(h_File)
#define h_File

// Defines
#define F_CPU 20000000
#define MCU ATMEGA644P

#include <avr\io.h>
#include "DirEntryCache.h"

#include "M8_Mx8_SPI.h"

#define String StringBig
/////// DEBUG /////////////
//#define IsDEBUG	// auch im Paket "Debug" schalten
	#define DEBUG_BAUD 500000
	#define DEBUG_UART_NR 0
	#include "debugUart.h"

class File
{

public:
	//	getDirEntry()
	//	gibt eine Referent auf sein DirEntryCache zurck
	DirEntryCache& getDirEntry();
	//	open()
	//	ffnet eine Datei
	bool open(DirEntryCache& dir);

	//	close()
	void close();
	//	readByte()
	//	Lesen eines Bytes aus einer Datei
	//	
	//	
	//	PA:
	//		gelesenes Byte, wenn fehler ist lastError!=0
	uint8_t readByte();
	//	getName()
	//	Gibt einen Zeiger auf den 8.3 Dateinamen im FAT-Directory-Eintrag zurck. Die ersten 8 Zeichen sind der Dateiname die folgenden 3 Zeichen sin die Erweiterung. Nicht bentigte Zeichen sind Leerzeichen (0x20).
	char* getName();

	//	getSize()
	uint32_t getSize();
	//	isEof()
	//	Testet auf End-Of-File, d.h. es gibt nichts mehr zu lesen. Der Dateizeiger steht dann hinter dem letztem Zeichen.
	//	
	//	
	//	PA:
	//		true wenn EOF
	bool isEof();
	//	open()
	//	ffnet eine Datei
	bool open(const char* fileName);
	bool isOpen;
	uint32_t absFilePointer;
	uint16_t secPosition;
	//	Sektor der aktuellen Position in der Datei
	uint32_t absSector;
	//	Cluster der aktuellen Position in der Datei
	uint16_t cluster;
	uint32_t fstSecOffClu;
	int8_t lastError;
	DirEntryCache entry;
	//	Konstruktor
	File();

	//	Destruktor
	~File();

private:

protected:

};

#endif
