///<ObjektNummer>2608</ObjektNummer>

#if !defined(h_StringBig)
#define h_StringBig

// Defines
#define F_CPU 20000000
#define MCU ATMEGA644P

#include <avr\io.h>
#include <string.h>
#include <avr/pgmspace.h>
#ifndef FLASHSTR
//#define FLASHSTR(s)  ((const uint8_t*)(PSTR(s)))
#define FLASHSTR(s) (__extension__({static prog_uchar PROGMEM __c[] = (s); &__c[0];}))
#endif
#include <stdio.h>
#include <ctype.h>
#define String StringBig
/////// DEBUG /////////////
//#define IsDEBUG	// auch im Paket "Debug" schalten
	#define DEBUG_BAUD 500000
	#define DEBUG_UART_NR 0
	#include "debugUart.h"

class StringBig
{

public:

	//	StringBig()
	 StringBig(const char* text);

	//	addContent()
	void addContent(const char* text, uint16_t size=-1);
	//	find()
	//	Liefert das erste auftreten eines Zeichens m String.
	//	
	//	
	//	PA:
	//		Zeichenposition oder -1, wenn nicht gefunden
	uint16_t find(char c, uint16_t startPos=0);

	//	getSize()
	uint16_t getSize() const;
	//	getPart()
	//	Gibt eine Teilzeichenkette zurck. Wenn zu viel angegeben wurde, wird nur bis zum Ende zurckgegeben. Wenn die Startporition zu gro oder anz gleich Null ist, wir eine leere Zeichenkette zurckgegeben.
	//	
	//	PE:
	//		startPos = Offset des ersten Zeichens (mit Null beginnend)
	//		anz = Anzahl der gewnschten Zeichen
	StringBig getPart(uint16_t startPos, uint16_t anz);

	//	operator char*()
	 operator char*();

	//	operator const char*()
	 operator const char*() const;

	//	operator+()
	StringBig operator+(const StringBig& text);

	//	operator+=()
	StringBig& operator+=(const StringBig& text);

	//	operator==()
	bool operator==(const StringBig& text) const;

	//	operator==()
	bool operator==(const prog_uchar* pText) const;

	//	setContent()
	bool setContent(const char* text, uint16_t size = -1);

	//	setSize()
	bool setSize(uint16_t newSize);
	//	toInt()
	//	Wandelt einen Sting in eien Zahl um. Es werden Hexadezimal-Zahlen (0x..), Binrzahlen (0b...) und Dezimalzahlen erkannt.
	//	
	//	PE:
	//		endPt = (optional) Zeiger auf Zeiger fr die Rckgabe der Position, an der das erste unbekannte Zeichen auftrat.
	//		
	//	PA:
	//		erkannte Zahl, Null bei Fehler
	uint32_t toInt(uint8_t** endPt=NULL /*Out*/);

	//	operator=()
	StringBig& operator=(const char* text);

	//	StringBig()
	 StringBig(const uint8_t* pText);

	//	operator=()
	StringBig& operator=(const StringBig& text);

	//	deinit()
	void deinit();

	//	StringBig()
	 StringBig(const StringBig& text);

	//	operator+=()
	StringBig& operator+=(const char c);

	//	operator=()
	StringBig& operator=(const prog_uchar* text);

	//	setContent()
	bool setContent(const prog_uchar* text, uint16_t size = -1);

	//	operator+=()
	StringBig& operator+=(const prog_uchar* c);

	//	addContent()
	void addContent(const prog_uchar* text, uint16_t size=-1);

	//	format()
	void format(const char* format, ...);

	//	getPartTo()
	StringBig getPartTo(char trenn);

	//	remove()
	void remove(uint16_t startPos, uint16_t anz);

	//	insert()
	void insert(const StringBig& text, uint16_t startPos);

	//	trim()
	void trim();

	//	replace()
	void replace(const char* txtOld, const char* txtNew);

	//	isspace()
	bool isspace(uint8_t c);

	//	urlDecode()
	void urlDecode();
	uint16_t len;
	uint8_t* pBuffer;
	//	Konstruktor
	StringBig();

	//	Destruktor
	~StringBig();

private:

protected:

};

	//	operator+()
	StringBig operator+(const char* txt1, const StringBig& txt2);

#endif
